=== debian/changelog ===
odyssey (1.5.0~rc3-1) unstable; urgency=medium

  * New upstream version 1.5.0~rc3.
  * Use arch:any again, package is now portable using ucontext lib.

 -- Christoph Berg <myon@debian.org>  Mon, 26 Jan 2026 20:10:53 +0100

odyssey (1.5.0~rc1-1) unstable; urgency=medium

  * New upstream version 1.5.0~rc1.

 -- Christoph Berg <myon@debian.org>  Mon, 19 Jan 2026 12:45:18 +0100
