=== debian/changelog ===
odyssey (1.5.0-1) unstable; urgency=medium

  * New upstream version 1.5.0.

 -- Christoph Berg <myon@debian.org>  Thu, 29 Jan 2026 18:11:53 +0100
