=== test/functional/tests/reload-show-clients/Makefile ===
test: show_clients reloads

show_clients:
	/tests/reload-show-clients/reloads.sh

reloads:
	/tests/reload-show-clients/show-clients.sh
