=== debian/changelog ===
odyssey (1.5.1~rc3-1) unstable; urgency=medium

  * New upstream version 1.5.1~rc3.

 -- Christoph Berg <myon@debian.org>  Mon, 23 Feb 2026 12:49:32 +0100

odyssey (1.5.1~rc2-1) unstable; urgency=medium

  * New upstream version 1.5.1~rc2.

 -- Christoph Berg <myon@debian.org>  Tue, 10 Feb 2026 14:16:43 +0100

odyssey (1.5.1~rc1-1) unstable; urgency=medium

  * New upstream version 1.5.1~rc1.

 -- Christoph Berg <myon@debian.org>  Thu, 05 Feb 2026 19:44:24 +0100
