=== debian/watch ===
Version: 5

Source: https://github.com/yandex/odyssey/tags
Matching-Pattern: .*/@ANY_VERSION@@ARCHIVE_EXT@
Uversionmangle: s/-?rc/~rc/
